# norootforbuild

%define     soname      120
%define     svn         20120126
%define     realname    libx264

Name:           x264
Summary:        A free h264/avc encoder - encoder binary
Version:        0.%{soname}svn%{svn}
Release:        4.6
License:        GPLv2+
Group:          Productivity/Multimedia/Video/Editors and Convertors
URL:            http://developers.videolan.org/x264.html
Source0:        ftp://ftp.videolan.org/pub/videolan/x264/snapshots/x264-snapshot-%{svn}-2245.tar.bz2
Patch0:         x264-use-shared-library.patch
BuildRoot:      %{_tmppath}/build-root-%{name}
BuildRequires:  nasm
BuildRequires:  yasm >= 1.0.1
BuildRequires:  pkgconfig

%description 
x264 is a free library for encoding next-generation H264/AVC video
streams. The code is written from scratch by Laurent Aimar, Loren
Merritt, Eric Petit (OS X), Min Chen (vfw/asm), Justin Clay (vfw), Mans
Rullgard, Radek Czyz, Christian Heine (asm), Alex Izvorski (asm), and
Alex Wright. It is released under the terms of the GPL license. This
package contains a shared library and a commandline tool for encoding
H264 streams. This library is needed for mplayer/mencoder for H264
encoding support.

Encoder features:
- CAVLC/CABAC
- Multi-references
- Intra: all macroblock types (16x16, 8x8, and 4x4 with all predictions)
- Inter P: all partitions (from 16x16 down to 4x4)
- Inter B: partitions from 16x16 down to 8x8 (including skip/direct)
- Ratecontrol: constant quantizer, single or multipass ABR, optional VBV
- Scene cut detection
- Adaptive B-frame placement
- B-frames as references / arbitrary frame order
- 8x8 and 4x4 adaptive spatial transform
- Lossless mode
- Custom quantization matrices
- Parallel encoding of multiple slices (currently disabled)

Be aware that the x264 library is still in early development stage. The
command line tool x264 can handle only raw YUV 4:2:0 streams at the
moment so please use mencoder or another tool that supports x264 library
for all other file types.

%package -n %{realname}-%{soname}
Summary:        A free h264/avc encoder - encoder binary
Group:          Productivity/Multimedia/Video/Editors and Convertors

%description -n %{realname}-%{soname}
x264 is a free library for encoding next-generation H264/AVC video
streams. The code is written from scratch by Laurent Aimar, Loren
Merritt, Eric Petit (OS X), Min Chen (vfw/asm), Justin Clay (vfw), Mans
Rullgard, Radek Czyz, Christian Heine (asm), Alex Izvorski (asm), and
Alex Wright. It is released under the terms of the GPL license. This
package contains a static library and a header needed for the
development with libx264. This library is needed to build
mplayer/mencoder with H264 encoding support.


%package -n %{realname}-devel
Summary:        Libraries and include file for the x264 encoder
Group:          Development/Libraries/C and C++
Requires:       %{realname}-%{soname} = %{version}-%{release}
Requires:       %{buildrequires}
Obsoletes:      x264-devel < %{version}-%{release}
Provides:       x264-devel = %{version}-%{release}

%description -n %{realname}-devel
x264 is a free library for encoding next-generation H264/AVC video
streams. The code is written from scratch by Laurent Aimar, Loren
Merritt, Eric Petit (OS X), Min Chen (vfw/asm), Justin Clay (vfw), Mans
Rullgard, Radek Czyz, Christian Heine (asm), Alex Izvorski (asm), and
Alex Wright. It is released under the terms of the GPL license. This
package contains a static library and a header needed for the
development with libx264. This library is needed to build
mplayer/mencoder with H264 encoding support.



%prep
%setup -q -n "x264-snapshot-%{svn}-2245"
%patch0 -p0
FAKE_BUILDDATE=$(LC_ALL=C date -u -r %{_sourcedir}/%{name}.changes '+%%b %%e %%Y')
sed -i "s/__DATE__/\"$FAKE_BUILDDATE\"/" x264.c

%build
%configure --enable-shared --enable-pic
%__make %{?jobs:-j%{jobs}}

%install
%makeinstall

%{__rm} -f "%{buildroot}/%{_libdir}/libx264.so"
%{__rm} -f "%{buildroot}/%{_libdir}/libx264.a"
%{__ln_s} libx264.so.%{soname} "%{buildroot}%{_libdir}/libx264.so"

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%post -n %{realname}-%{soname} -p /sbin/ldconfig
%postun -n %{realname}-%{soname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc doc/*.txt
%attr(0755,root,root) %{_bindir}/x264

%files -n %{realname}-%{soname}
%defattr(0644,root,root)
%{_libdir}/libx264.so.%{soname}

%files -n %{realname}-devel
%defattr(0644,root,root)
%{_libdir}/pkgconfig/x264.pc
%{_includedir}/x264.h
%{_includedir}/x264_config.h
%{_libdir}/libx264.so

%changelog
* Sun Feb 26 2012 cs@linux-administrator.com
- re-import
